/* strumfun -- yeh yeh yeh 
 *
 * this will check for available MIDI ports (started with the
 * "startmidi" command) and read MIDI data from one; either the
 * internal "Software Synth" port or a named port given as the
 * first argument to this command: "testmidi jeeves" would try
 * to read data from a MIDI port named "jeeves"
 *
 * BGG
 * HA HA HA no it woin't
*/

#include <stdio.h>
#include <dmedia/midi.h>
#include <poll.h>
#include <sys/select.h>
#include "/musr/cmix/H/RTsockfuncs.h"

int RTpid, theSock;

void main(int argc, char *argv[]) {
   int i, nports;
   int nfds;
   MDevent mdv;
   MDport inport; 
   char *portName;
   char *rportName;
   struct pollfd pfd;

        /* start up the instrument */
        RTpid = RTopensocket(0, "STRUM -c");
        sleep(3); /* allow the process time to start */

        /* open up the socket */
        theSock = RTsock("localhost", 0);

        /* set up the instrument */
        RTsendsock("rtsetparams", theSock, 3, 44100.0, 2.0, 256.0);
/*
        RTsendsock("print_off", theSock, 0);
// p0 = start; p1 = dur; p2 = pitch (oct.pc); p3 = fundamental decay time
// p4 = nyquist decay time; p5 = distortion gain; p6 = feedback gain
// p7 = feedback pitch (oct.pc); p8 = clean signal level
// p9 = distortion signal level; p10 = amp; p11 = squish
// p12 = stereo spread [optional]
// p13 = flag for deleting pluck arrays (used by FRET, BEND, etc
*/

        sleep(2);
        RTsendsock("START1", theSock, 13, 0.0, 99.0, 7.03, 99.0, 99.0,
0.0000001, 0.00001, 7.03, 0.0, 1.0, 1.0, 1.0, 0.5);


   /* initialize and count how many midi ports are available */
   nports = mdInit();
   printf("There are %d MIDI ports available\n",nports);
   if (nports <= 0) exit(0);


   /* print out the various port names */
   printf(" -- Here are their names:\n");
   for(i = 0; i < nports; i++) {
      portName = mdGetName(i);
      printf("     %s\n",portName);
   }
   printf("  (and the internal \"Software Synth\", of course!)\n");

   if (argc == 2) {
      rportName = argv[1];
   }
   else {
      rportName = portName;
   }


   /* open the midi port */
   printf("I am opening port \"%s\" for reading...\n",rportName);
   inport = mdOpenInPort(rportName);
   if (inport == NULL) {
      fprintf(stderr,"Open of MIDI port \"%s\" failed, sorry!\n",rportName);
      exit(-1);
   }


   /* no need to timestamp. */
   mdSetStampMode(inport, MD_NOSTAMP);


   /* poll for input on the file descriptor */
   pfd.fd = mdGetFd(inport);
   pfd.events = POLLIN;
   while(1) {
      nfds = poll(&pfd, 1, -1);

      if (nfds == 1) {
         if (mdReceive(inport, &mdv, 1) < 0) {
            printf("failure receiving message\n");
               abort();
               exit(-1);
            }

         if (mdv.msg[0] == MD_NOTEON) { /* there are a bunch of these defines
                                                            in dmedia/midi.h */
            printf("note on: %d;  velocity: %d\n",(int)mdv.msg[1],(int)mdv.msg[2]);
         }
         else if (mdv.msg[0] == MD_NOTEOFF) {
            printf("note off: %d;  velocity: %d\n",(int)mdv.msg[1],(int)mdv.msg[2]);
         }
         else {
            printf("some other event... here are the bytes:\n");
            printf("   0: %d\n",(int)mdv.msg[0]);
            printf("   1: %d\n",(int)mdv.msg[1]);
            printf("   2: %d\n",(int)mdv.msg[2]);
            printf("   3: %d\n",(int)mdv.msg[3]);
		switch ((int)mdv.msg[1]) {
			case 71:
				RTsendsock("rtupdate", theSock, 3, 1.0, 10.0, (float)((int)mdv.msg[2]*100));
				break;
			case 72:
				RTsendsock("rtupdate", theSock, 3, 1.0, 2.0, (float)((int)mdv.msg[2]+100));
				break;
			case 73:
				RTsendsock("rtupdate", theSock, 3, 1.0, 5.0, (float)((float)mdv.msg[2]/10000.0));
				break;
			case 74:
				RTsendsock("rtupdate", theSock, 3, 1.0, 6.0, (float)((int)mdv.msg[2]));
				break;
		}
         }
         if (mdv.msg[0] == MD_SYSEX) /* not sure what this is for */
            mdFree(mdv.sysexmsg);
      }
   }
}
